#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/**
Napite program, kter Vm umon jednoduchou evidenci
Vaich kontakt. Ke kadmu kontaktu si budete
pamatovat:
jmno - etzec max. 25 znak
pjmen - etzec max. 25 znak
adresu:
ulice - etzec max. 50 znak
slo domu - cel slo bez znamnka
msto - etzec max. 50 znak
PS - cel slo bez znamnka
telefonn slo - etzec man 13 znak
Program bude umovat nsledujc operace:

vytvoen nov, przdn kartotky - provede se
     automaticky, pokud kartotka nebude existovat,
     jinak pouze pokud si to bude pt uivatel.
pidn jednoho zznamu
vyhledn zznamu podle jmna a pjmen
vpis vech zznam na standardn vstup
export kartotky do textovho souboru ve formtu CSV
ukonit innost.
Ovldn bude eeno pomoc textovho menu, kter
uivateli umon volbu provdn akce. Data budou
uchovvna pouze v souboru (v pamti bude pouze
aktuln zpracovvan zznam).
*/
typedef enum{UNDEF = -1, NEW,ADD,SEARCH,LIST,EXPORT,QUIT} Action;
typedef struct
{
     char  name[26];
     char  sname[26];
     struct
     {
        char street[51];
        unsigned housenum;
        char town[51];
        unsigned postcode;
    }adress;
    char phonenum[14];
}Contact;

#define FILE_NAME "kart.dat"


FILE *create(char *fname);
Action menu();
Contact search(FILE *f,char *name,char* sname);
void addContact(FILE *f);
void readString(char* label,char *data,int size);
void listContact(Contact contact);
void listContacts(FILE *f);
void exportFile(FILE *src,FILE *dst);
Contact readContact();
void cleanInput();
int removeNL(char *where);
int main()
{
    FILE *f = fopen(FILE_NAME,"r+b");
    if(f==NULL)f=create(FILE_NAME);
    char name[26];
    char sname[26];
    char outFName[255];

    if(f==NULL){
        f=create(FILE_NAME);
    }
    Action akce = menu();
    while(akce!=QUIT)
    {
        switch(akce)
        {
            case NEW:create(FILE_NAME);break;
            case ADD:addContact(f);break;
            case SEARCH:readString("Jmeno",name,25);
                        readString("Prijmeni",sname,25);
                        Contact cont = search(f,name,sname);
                        listContact(cont);
                        break;
            case LIST:  listContacts(f);
                        break;
            case EXPORT:readString("Soubor pro export",outFName,254);
                        FILE *output = create(outFName);
                        exportFile(f,output);
                        fclose(output);
                        break;
            default:;
        }
        akce = menu();
    }
    fclose(f);
    return 0;
}

void addContact(FILE *f)
{
    Contact cont = readContact();
    fwrite(&cont,sizeof(Contact),1,f);
    fflush(f);
}

Contact readContact()
{
    Contact cont;
    readString("Jmeno",cont.name,25);
    readString("Prijmeni",cont.sname,25);
    readString("Ulice",cont.adress.street,50);
    printf("Cislo domu:");
    scanf("%u",&cont.adress.housenum);
    cleanInput();
    readString("Mesto",cont.adress.town,50);
    printf("PSC:");
    scanf("%u",&cont.adress.postcode);
    cleanInput();
    readString("Tel:",cont.phonenum,13);
    return cont;
}

void cleanInput()
{
    while(getchar()!='\n');
}

Contact search(FILE *f,char *name,char* sname)
{
    Contact result;
    int pos = ftell(f);
    rewind(f);
    fread(&result, sizeof(Contact),1,f);
    while(!feof(f))
    {
        if(strcmp(result.name,name)==0 && strcmp(result.sname, sname) == 0){
            {
                fseek(f,pos,SEEK_SET);
                return result;
            }
        }
        fread(&result, sizeof(Contact),1,f);
    }
    result.name[0] = '\0';
    result.sname[0] = '\0';
    fseek(f,pos,SEEK_SET);
    return result;
}


void readString(char* label,char *data,int size)
{
    printf("%s",label);
    fgets(data,size,stdin);
    if(!removeNL(data)){
        cleanInput();
    }
}

int removeNL(char *where)
{
    char *nl = strchr(where,'\n');
    if(nl){
        *nl = 0;
        return 1;
    }
    return 0;
}

void listContact(Contact contact)
{
    printf("jmeno: %s\nprijmeni: %s\n",contact.name,
                                     contact.sname);
    printf("Adresa: %s %u, %u %s\n",
           contact.adress.street,
           contact.adress.housenum,
           contact.adress.postcode,
           contact.adress.town);
    printf("Tel:%s\n",contact.phonenum);
}

void listContacts(FILE *f)
{
    Contact cont;
    int pos = ftell(f);
    rewind(f);
    fread(&cont,sizeof(Contact),1,f);
    while(!feof(f))
    {
        listContact(cont);
        fread(&cont,sizeof(Contact),1,f);
    }
    fseek(f,pos,SEEK_SET);
}

void exportFile(FILE *src,FILE *dst)
{
    int pos = ftell(src);
    rewind(src);
    Contact cont;
    fread(&cont,sizeof(Contact),1,src);
    while(!feof(src))
    {
        fprintf(dst,"%s;%s;%s;%u;%s;%u;%s\n",
                cont.name,cont.sname,
                cont.adress.street,cont.adress.housenum,
                cont.adress.town,cont.adress.postcode,
                cont.phonenum);
        fread(&cont,sizeof(Contact),1,src);
    }
    fseek(src,pos,SEEK_SET);
    fflush(dst);
}

FILE *create(char *fname)
{
    return fopen(fname,"w+b");
}

Action menu()
{
    int action;
    printf("1. Nova kartoteka\n2. Pridat zaznam\n");
    printf("3. Vyhledat zaznam\n4. Vypsat zaznamy\n");
    printf("5. Export do CSV\n6. Konec\n");
    printf("Akce (1-6):");
    scanf("%d",&action);
    if(action<1 || action > 6){
        action = 0;
    }
    cleanInput();
    return action - 1;
}
